//::///////////////////////////////////////////////
//:: Name; farm_config
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    This script houses all of the configureable
        options for the NWN Farming System.
*/
//:://////////////////////////////////////////////
//:: Created By: Adam Walenga
//:: Created On: September 5th, 2004
//:://////////////////////////////////////////////

//MINUTES_PER_HOUR -
//Used by the 'Enhanced Delay System'
//This value can be found here:  Module Properties -> Advanced -> Minutes/Hour.
//It is very important to correctly set this value, otherwise delays using
//this system will not properly function.
const int MINUTES_PER_HOUR = 3;

//FARM_LIMIT_LOOTING -
//This variable controls the ability for PCs to loot crops grown in farms
//    not currently owned by him/her.  Setting this variable to TRUE will
//    enable this option, and allow crops only to be looted by the owner of
//    the farm with which it was grown in.
const int FARM_LIMIT_LOOTING = TRUE;

//FARM_PLANT_DELAY -
//This variable controls the time (in seconds) required to plant seeds.
const float FARM_PLANT_DELAY = 6.0f;

//FARM_SHOVEL_BREAKAGE -
//    This variable controls the percentage of breakage for the "Planter's
//        Shovel".  Setting this variable to 0 will allow for the shovels
//        to never break.
const int FARM_SHOVEL_BREAKAGE = 1;

//BEGINNING_LAND_OWNER -
//    This variable is used for the selling of farms.  If the farm has never
//        been purchased yet, then the owner's name is specified below.  Once
//        purchased and put up for sale, the owner's name will appear instead
//        of this one.
const string FARM_INIT_LAND_OWNER = "Lord Balder";

//CRAFTING SYSTEM(S) COMPATIBILITY -
//The variable(s) listed below will allow for compatibility mode between this
//    system, and a crafting system currently implemented in the module.  No
//    more than one of these variables should be enabled.  If any are enabled,
//    The NWN Farming System will use resources from that system, rather than
//    the ones created with this system (i.e. if using CNR and enabled variable,
//    corn seeds planted from this system will spawn the CNR version of the corn
//    placeable (thus also producing CNR-related resources)).
const int FARM_USE_CNR_RESOURCES = FALSE;
