// Dispel Magic Override by Mhzentul Lafarius

// From Siggy
// Cast dispel on someone, roll a d20 for each buff that person has.
// Add a modifer rolls. If roll + modifer is passes the DC check strip that buff.
// The DC check is 11 + caster level of the buffed mage.
//
#include "inc_tokenizer"
#include "prc_inc_spells"

// roll D20 + nCasterLevel Against 11+Target Arcane Level
float GetRandomDelay(float fMinimumTime = 0.4, float MaximumTime = 1.1);
int spellsIsTarget(object oTarget, int nTargetType, object oSource);
int RemoveProtections(int nSpell_ID, object oTarget, int nCount);
int GetSpellBreachProtection(int nLastChecked);

string getSpellNameFromID(int nSpellID);

void AltspellsDispelMagic(object oTarget, int nCasterLevel, effect eVis, effect eImpac)
{
    effect eDispel;
    float fDelay = GetRandomDelay(1.0, 2.0);

    // Visual Special Effect
    DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget));
    if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    {
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, PRCGetSpellId()));
    }
    else
    {
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, PRCGetSpellId(), FALSE));
    }
    // If Ennemy, Attempt Dispels
    if(GetIsEnemy(oTarget))
    {
        int nRoll;
        int nDC;
        int nSpellID;
        string sSpellID;
        string szMessage;
        string tkSpellIds = "";
        //eDispel = EffectDispelMagicBest(nCasterLevel);
        effect eEffect = GetFirstEffect(oTarget);
        //Search for negative effects
        while(GetIsEffectValid(eEffect))
        {

                nSpellID = GetEffectSpellId(eEffect);
                sSpellID = IntToString(nSpellID);

                if (!GetIsTokenInString(sSpellID, tkSpellIds))
                {
                    tkSpellIds =  AddTokenToString(sSpellID, tkSpellIds);
                    nRoll = d20(1);
                    nDC   = 11 + PRCGetCasterLevel(oTarget);

                    szMessage = "Dispel Magic : ";
                    szMessage = szMessage + GetName(oTarget) +" : Save vs DC : ";
                    szMessage = szMessage + getSpellNameFromID(nSpellID);
                    //Remove effect if DC Failed
                    if (nRoll + nCasterLevel >=nDC)
                    {
                        szMessage = szMessage +" : *failure*";
                        RemoveEffect(oTarget, eEffect);
                        //DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDispel, oTarget));
                    }
                    else
                    {
                         szMessage = szMessage +" : *success*";
                    }
                    szMessage = szMessage + "("+IntToString(nRoll)+"+"+IntToString(nCasterLevel)+" = ";
                    szMessage = szMessage + IntToString(nRoll+nCasterLevel) +" vs. DC: " + IntToString(nDC) +")";
                    SendMessageToPC(oTarget,szMessage);
                    SendMessageToPC(OBJECT_SELF,szMessage);
                }
                eEffect = GetNextEffect(oTarget);
        }
    }

}

string getSpellNameFromID(int nSpellID)
{

  string sName = "Unknown Spell";
  switch(nSpellID)
  {
  case 0: sName = "Acid Fog"; break;
  case 1: sName = "Aid"; break;
  case 2: sName = "Animate Dead"; break;
  case 195: sName = "Aura, Blinding"; break;
  case 196: sName = "Aura, Cold"; break;
  case 197: sName = "Aura, Electricity"; break;
  case 412: sName = "Aura, Fear Dragon"; break;
  case 198: sName = "Aura, Fear"; break;
  case 199: sName = "Aura, Fire"; break;
  case 200: sName = "Aura, Menace"; break;
  case 314: sName = "Aura, Of Courage"; break;
  case 372: sName = "Aura, Of Vitality"; break;
  case 201: sName = "Aura, Protection"; break;
  case 202: sName = "Aura, Stun"; break;
  case 203: sName = "Aura, Unearthly Visage"; break;
  case 204: sName = "Aura, Unnatural"; break;
  case 323: sName = "Aura, Versus Alignment"; break;
  case 363: sName = "Awaken"; break;
  case 307: sName = "Barbarian Rage"; break;
  case 411: sName = "Bards Song"; break;
  case 3: sName = "Barkskin"; break;
  case 380: sName = "Battle Mastery Spell"; break;
  case 4: sName = "Bestow Curse"; break;
  case 5: sName = "Blade Barrier"; break;
  case 7: sName = "Bless Weapon"; break;
  case 6: sName = "Bless"; break;
  case 8: sName = "Blindness And Deafness"; break;
  case 277: sName = "Body Adjustment, Lesser"; break;
  case 205: sName = "Bolt, Ability Drain Charisma"; break;
  case 206: sName = "Bolt, Ability Drain Constitution"; break;
  case 207: sName = "Bolt, Ability Drain Dexterity"; break;
  case 208: sName = "Bolt, Ability Drain Intelligence"; break;
  case 209: sName = "Bolt, Ability Drain Strength"; break;
  case 210: sName = "Bolt, Ability Drain Wisdom"; break;
  case 211: sName = "Bolt, Acid"; break;
  case 212: sName = "Bolt, Charm"; break;
  case 213: sName = "Bolt, Cold"; break;
  case 214: sName = "Bolt, Confuse"; break;
  case 215: sName = "Bolt, Daze"; break;
  case 216: sName = "Bolt, Death"; break;
  case 217: sName = "Bolt, Disease"; break;
  case 218: sName = "Bolt, Dominate"; break;
  case 219: sName = "Bolt, Fire"; break;
  case 220: sName = "Bolt, Knockdown"; break;
  case 221: sName = "Bolt, Level Drain"; break;
  case 222: sName = "Bolt, Lightning"; break;
  case 223: sName = "Bolt, Paralyze"; break;
  case 224: sName = "Bolt, Poison"; break;
  case 225: sName = "Bolt, Shards"; break;
  case 226: sName = "Bolt, Slow"; break;
  case 227: sName = "Bolt, Stun"; break;
  case 228: sName = "Bolt, Web"; break;
  case 9: sName = "Bull's Strength"; break;
  case 360: sName = "Bull's Strength, Greater"; break;
  case 10: sName = "Burning Hands"; break;
  case 11: sName = "Call Lightning"; break;
  case 12: sName = "Calm Emotions"; break;
  case 13: sName = "Cat's Grace"; break;
  case 361: sName = "Cat's Grace, Greater"; break;
  case 14: sName = "Chain Lightning"; break;
  case 15: sName = "Charm Monster"; break;
  case 17: sName = "Charm Person Or Animal"; break;
  case 16: sName = "Charm Person"; break;
  case 18: sName = "Circle Of Death"; break;
  case 19: sName = "Circle Of Doom"; break;
  case 20: sName = "Clairaudience And Clairvoyance"; break;
  case 21: sName = "Clarity"; break;
  case 22: sName = "Cloak Of Chaos"; break;
  case 23: sName = "Cloudkill"; break;
  case 24: sName = "Color Spray"; break;
  case 229: sName = "Cone, Acid"; break;
  case 230: sName = "Cone, Cold"; break;
  case 231: sName = "Cone, Disease"; break;
  case 232: sName = "Cone, Fire"; break;
  case 233: sName = "Cone, Lightning"; break;
  case 25: sName = "Cone Of Cold"; break;
  case 234: sName = "Cone, Poison"; break;
  case 235: sName = "Cone, Sonic"; break;
  case 26: sName = "Confusion"; break;
  case 27: sName = "Contagion"; break;
  case 28: sName = "Control Undead"; break;
  case 30: sName = "Create Undead"; break;
  case 29: sName = "Create Greater Undead"; break;
  case SPELL_CREEPING_DOOM: sName = "Creeping Doom"; break;
  case 31: sName = "Cure Critical Wounds"; break;
  case 32: sName = "Cure Light Wounds"; break;
  case 33: sName = "Cure Minor Wounds"; break;
  case 34: sName = "Cure Moderate Wounds"; break;
  case 35: sName = "Cure Serious Wounds"; break;
  case SPELL_DARKNESS: sName = "Darkness"; break;
  case 37: sName = "Daze"; break;
  case 38: sName = "Death Ward"; break;
  case 39: sName = "Delayed Blast Fireball"; break;
  case 366: sName = "Destruction"; break;
  case 312: sName = "Detect Evil"; break;
  case 40: sName = "Dismissal"; break;
  case 41: sName = "Dispel Magic"; break;
  case 94: sName = "Dispel, Lesser"; break;
  case 67: sName = "Dispelling, Greater"; break;
  case 42: sName = "Divine Power"; break;
  case 382: sName = "Divine Protection"; break;
  case 381: sName = "Divine Strength"; break;
  case 384: sName = "Divine Trickery"; break;
  case 43: sName = "Dominate Animal"; break;
  case 44: sName = "Dominate Monster"; break;
  case 45: sName = "Dominate Person"; break;
  case 46: sName = "Doom"; break;
  case 236: sName = "Dragon Breath, Acid"; break;
  case 237: sName = "Dragon Breath, Cold"; break;
  case 238: sName = "Dragon Breath, Fear"; break;
  case 239: sName = "Dragon Breath, Fire"; break;
  case 240: sName = "Dragon Breath, Gas"; break;
  case 241: sName = "Dragon Breath, Lightning"; break;
  case 242: sName = "Dragon Breath, Paralyze"; break;
  case 243: sName = "Dragon Breath, Sleep"; break;
  case 244: sName = "Dragon Breath, Slow"; break;
  case 245: sName = "Dragon Breath, Weaken"; break;
  case 246: sName = "Dragon Wing Buffet"; break;
  case 354: sName = "Eagle Splendor"; break;
  case 357: sName = "Eagle Splendor, Greater"; break;
  case 400: sName = "Elemental Shape, Air"; break;
  case 399: sName = "Elemental Shape, Earth"; break;
  case 397: sName = "Elemental Shape, Fire"; break;
  case 398: sName = "Elemental Shape, Water"; break;
  case 319: sName = "Elemental Shape"; break;
  case 47: sName = "Elemental Shield"; break;
  case 48: sName = "Elemental Swarm"; break;
  case 311: sName = "Empty Body"; break;
  case 49: sName = "Endurance"; break;
  case 362: sName = "Endurance, Greater"; break;
  case 50: sName = "Endure Elements"; break;
  case 369: sName = "Energy Buffer"; break;
  case 51: sName = "Energy Drain"; break;
  case 52: sName = "Enervation"; break;
  case 53: sName = "Entangle"; break;
  case 121: sName = "Ethereal Visage"; break;
  case 375: sName = "Evard's Black Tentacles"; break;
  case 54: sName = "Fear"; break;
  case 55: sName = "Feeblemind"; break;
  case 247: sName = "Ferocity 1"; break;
  case 248: sName = "Ferocity 2"; break;
  case 249: sName = "Ferocity 3"; break;
  case 377: sName = "Find Traps"; break;
  case 56: sName = "Finger Of Death"; break;
  case 57: sName = "Fire Storm"; break;
  case 58: sName = "Fireball"; break;
  case 59: sName = "Flame, Arrow"; break;
  case 60: sName = "Flame, Lash"; break;
  case 61: sName = "Flame, Strike"; break;
  case 359: sName = "Foxs Cunning, Greater"; break;
  case 356: sName = "Foxs Cunning"; break;
  case 62: sName = "Freedom Of Movement"; break;
  case 63: sName = "Gate"; break;
  case 250: sName = "Gaze, Charm"; break;
  case 251: sName = "Gaze, Confusion"; break;
  case 252: sName = "Gaze, Daze"; break;
  case 253: sName = "Gaze, Death"; break;
  case 254: sName = "Gaze, Destroy Chaos"; break;
  case 255: sName = "Gaze, Destroy Evil"; break;
  case 256: sName = "Gaze, Destroy Good"; break;
  case 257: sName = "Gaze, Destroy Law"; break;
  case 258: sName = "Gaze, Dominate"; break;
  case 259: sName = "Gaze, Doom"; break;
  case 260: sName = "Gaze, Fear"; break;
  case 261: sName = "Gaze, Paralysis"; break;
  case 262: sName = "Gaze, Stunned"; break;
  case 120: sName = "Ghostly Visage"; break;
  case 64: sName = "Ghoul Touch"; break;
  case 65: sName = "Globe Of Invulnerability"; break;
  case 263: sName = "Golem Breath Gas"; break;
  case 66: sName = "Grease"; break;
  case 75: sName = "Gust Of Wind"; break;
  case 76: sName = "Hammer Of The Gods"; break;
  case 77: sName = "Harm"; break;
  case 78: sName = "Haste"; break;
  case 80: sName = "Healing Circle"; break;
  case 79: sName = "Heal"; break;
  case 264: sName = "Hell Hound Firebreath"; break;
  case 81: sName = "Hold Animal"; break;
  case 82: sName = "Hold Monster"; break;
  case 83: sName = "Hold Person"; break;
  case 84: sName = "Holy Aura"; break;
  case 85: sName = "Holy Sword"; break;
  case 367: sName = "Horrid Wilting"; break;
  case 265: sName = "Howl, Confuse"; break;
  case 266: sName = "Howl, Daze"; break;
  case 267: sName = "Howl, Death"; break;
  case 268: sName = "Howl, Doom"; break;
  case 269: sName = "Howl, Fear"; break;
  case 270: sName = "Howl, Paralysis"; break;
  case 271: sName = "Howl, Sonic"; break;
  case 272: sName = "Howl, Stun"; break;
  case 368: sName = "Ice Storm"; break;
  case 86: sName = "Identify"; break;
  case 87: sName = "Implosion"; break;
  case 88: sName = "Improved Invisibility"; break;
  case 89: sName = "Incendiary Cloud"; break;
  case 273: sName = "Intensity 1"; break;
  case 274: sName = "Intensity 2"; break;
  case 275: sName = "Intensity 3"; break;
  case 90: sName = "Invisibility"; break;
  case 91: sName = "Invisibility, Purge"; break;
  case 92: sName = "Invisibility, Sphere"; break;
  case 93: sName = "Knock"; break;
  case 276: sName = "Krenshar Scare"; break;
  case 313: sName = "Lay On Hands"; break;
  case 376: sName = "Legend Lore"; break;
  case 101: sName = "Lightning Bolt"; break;
  case 100: sName = "Light"; break;
  case 102: sName = "Mage Armor"; break;
  case 322: sName = "Magic Circle Against Alignment"; break;
  case 103: sName = "Magic Circle Against Chaos"; break;
  case 104: sName = "Magic Circle Against Evil"; break;
  case 105: sName = "Magic Circle Against Good"; break;
  case 106: sName = "Magic Circle Against Law"; break;
  case 107: sName = "Magic Missile"; break;
  case 108: sName = "Magic Vestment"; break;
  case 109: sName = "Magic Weapon"; break;
  case 68: sName = "Magic Weapon, Greater"; break;
  case 110: sName = "Mass Blindness And Deafness"; break;
  case 111: sName = "Mass Charm"; break;
  case 112: sName = "Mass Domination"; break;
  case 113: sName = "Mass Haste"; break;
  case 114: sName = "Mass Heal"; break;
  case 115: sName = "Melf's Acid Arrow"; break;
  case 278: sName = "Mephit Salt Breath"; break;
  case 279: sName = "Mephit Steam Breath"; break;
  case 116: sName = "Meteor Swarm"; break;
  case 117: sName = "Mind Blank"; break;
  case 95: sName = "Mind Blank, Lesser"; break;
  case 118: sName = "Mind Fog"; break;
  case 119: sName = "Minor Globe Of Invulnerability"; break;
  case 122: sName = "Mordenkainen's Disjunction"; break;
  case 123: sName = "Mordenkainen's Sword"; break;
  case 280: sName = "Mummy Bolster Undead"; break;
  case 124: sName = "Nature's Balance"; break;
  case 370: sName = "Negative Energy, Burst"; break;
  case 125: sName = "Negative Energy, Protection"; break;
  case 371: sName = "Negative Energy, Ray"; break;
  case 383: sName = "Negative Plane Avatar"; break;
  case 126: sName = "Neutralize Poison"; break;
  case 355: sName = "Owls Wisdom"; break;
  case 358: sName = "Owls Wisdom, Greater"; break;
  case 127: sName = "Phantasmal Killer"; break;
  case 128: sName = "Planar Binding"; break;
  case 96: sName = "Planar Binding, Lesser"; break;
  case 69: sName = "Planar Binding, Greater"; break;
  case 129: sName = "Poison"; break;
  case 387: sName = "Polymorph, Giant Spider"; break;
  case 390: sName = "Polymorph, Pixie"; break;
  case 130: sName = "Polymorph, Self"; break;
  case 388: sName = "Polymorph, Troll"; break;
  case 389: sName = "Polymorph, Umber Hulk"; break;
  case 391: sName = "Polymorph, Zombie"; break;
  case 131: sName = "Power Word Kill"; break;
  case 132: sName = "Power Word Stun"; break;
  case 133: sName = "Prayer"; break;
  case 134: sName = "Premonition"; break;
  case 135: sName = "Prismatic Spray"; break;
  case 321: sName = "Protection From Alignment"; break;
  case 136: sName = "Protection From Chaos"; break;
  case 137: sName = "Protection From Elements"; break;
  case 138: sName = "Protection From Evil"; break;
  case 139: sName = "Protection From Good"; break;
  case 140: sName = "Protection From Law"; break;
  case 141: sName = "Protection From Spells"; break;
  case 292: sName = "Pulse Ability, Drain Charisma"; break;
  case 293: sName = "Pulse Ability, Drain Constitution"; break;
  case 294: sName = "Pulse Ability, Drain Dexterity"; break;
  case 291: sName = "Pulse Ability, Drain Intelligence"; break;
  case 295: sName = "Pulse Ability, Drain Strength"; break;
  case 296: sName = "Pulse Ability, Drain Wisdom"; break;
  case 286: sName = "Pulse, Cold"; break;
  case 289: sName = "Pulse, Death"; break;
  case 298: sName = "Pulse, Disease"; break;
  case 281: sName = "Pulse, Drown"; break;
  case 284: sName = "Pulse, Fire"; break;
  case 288: sName = "Pulse, Holy"; break;
  case 290: sName = "Pulse, Level Drain"; break;
  case 285: sName = "Pulse, Lightning"; break;
  case 287: sName = "Pulse, Negative"; break;
  case 297: sName = "Pulse, Poison"; break;
  case 282: sName = "Pulse, Spores"; break;
  case 283: sName = "Pulse, Whirlwind"; break;
  case 310: sName = "Quivering Palm"; break;
  case 299: sName = "Rage, 3"; break;
  case 300: sName = "Rage, 4"; break;
  case 301: sName = "Rage, 5"; break;
  case 142: sName = "Raise Dead"; break;
  case 143: sName = "Ray Of Enfeeblement"; break;
  case 144: sName = "Ray Of Frost"; break;
  case 374: sName = "Regenerate"; break;
  case 145: sName = "Remove Blindness And Deafness"; break;
  case 146: sName = "Remove Curse"; break;
  case 147: sName = "Remove Disease"; break;
  case 316: sName = "Remove Disease"; break;
  case 148: sName = "Remove Fear"; break;
  case 149: sName = "Remove Paralysis"; break;
  case 150: sName = "Resist Elements"; break;
  case 151: sName = "Resistance"; break;
  case 152: sName = "Restoration"; break;
  case 97: sName = "Restoration, Lesser"; break;
  case 70: sName = "Restoration, Greater"; break;
  case 153: sName = "Resurrection"; break;
  case 385: sName = "Rogues Cunning"; break;
  case 154: sName = "Sanctuary"; break;
  case 155: sName = "Scare"; break;
  case 156: sName = "Searing Light"; break;
  case 157: sName = "See Invisibility"; break;
  case 158: sName = "Shades"; break;
  case 340: sName = "Shades: Cone Of Cold"; break;
  case 341: sName = "Shades: Fireball"; break;
  case 342: sName = "Shades: Stoneskin"; break;
  case 324: sName = "Shades: Summon Shadow"; break;
  case 343: sName = "Shades: Wall Of Fire"; break;
  case 159: sName = "Shadow Conjuration"; break;
  case 345: sName = "Shadow: Darkness"; break;
  case 346: sName = "Shadow: Inivsibility"; break;
  case 347: sName = "Shadow: Mage Armor"; break;
  case 348: sName = "Shadow: Magic Missile"; break;
  case 344: sName = "Shadow: Summon Shadow"; break;
  case 71: sName = "Shadow Conjuration, Greater"; break;
  case 350: sName = "Shadow, Greater: Acid Arrow"; break;
  case 351: sName = "Shadow, Greater: Ghostly Visage"; break;
  case 353: sName = "Shadow, Greater: Minor Globe"; break;
  case 349: sName = "Shadow, Greater: Summon Shadow"; break;
  case 352: sName = "Shadow, Greater: Web"; break;
  case 160: sName = "Shadow Shield"; break;
  case 394: sName = "Shapechange, Balor"; break;
  case 395: sName = "Shapechange, Death Slaad"; break;
  case 393: sName = "Shapechange, Fire Giant"; break;
  case 396: sName = "Shapechange, Iron Golem"; break;
  case 392: sName = "Shapechange, Red Dragon"; break;
  case 161: sName = "Shapechange"; break;
  case 162: sName = "Shield Of Law"; break;
  case 163: sName = "Silence"; break;
  case 164: sName = "Slay Living"; break;
  case 165: sName = "Sleep"; break;
  case 166: sName = "Slow"; break;
  case 315: sName = "Smite Evil"; break;
  case 302: sName = "Smoke Claw"; break;
  case 167: sName = "Sound Burst"; break;
  case 406: sName = "Special Alcohol, Beer"; break;
  case 408: sName = "Special Alcohol, Spirits"; break;
  case 407: sName = "Special Alcohol, Wine"; break;
  case 409: sName = "Special Herb, Belladonna"; break;
  case 410: sName = "Special Herb, Garlic"; break;
  case 98: sName = "Spell Breach, Lesser"; break;
  case 72: sName = "Spell Breach, Greater"; break;
  case 169: sName = "Spell Mantle"; break;
  case 99: sName = "Spell Mantle, Lesser"; break;
  case 73: sName = "Spell Mantle, Greater"; break;
  case 168: sName = "Spell Resistance"; break;
  case 170: sName = "Sphere Of Chaos"; break;
  case 171: sName = "Stinking Cloud"; break;
  case 172: sName = "Stoneskin"; break;
  case 74: sName = "Stoneskin, Greater"; break;
  case 173: sName = "Storm Of Vengeance"; break;
  case 317: sName = "Summon Animal Companion"; break;
  case 379: sName = "Summon Celestial"; break;
  case 174: sName = "Summon Creature, 1"; break;
  case 175: sName = "Summon Creature, 2"; break;
  case 176: sName = "Summon Creature, 3"; break;
  case 177: sName = "Summon Creature, 4"; break;
  case 179: sName = "Summon Creature, 5"; break;
  case 180: sName = "Summon Creature, 6"; break;
  case 181: sName = "Summon Creature, 7"; break;
  case 182: sName = "Summon Creature, 8"; break;
  case 178: sName = "Summon Creature, 9"; break;
  case 318: sName = "Summon Familiar"; break;
  case 378: sName = "Summon Mephit"; break;
  case 303: sName = "Summon Slaad"; break;
  case 304: sName = "Summon Tanarri"; break;
  case 183: sName = "Sunbeam"; break;
  case 184: sName = "Tenser's Transformation"; break;
  case 185: sName = "Time Stop"; break;
  case 186: sName = "True Seeing"; break;
  case 305: sName = "Trumpet Blast"; break;
  case 308: sName = "Turn Undead"; break;
  case 306: sName = "Tyrant Fog Mist"; break;
  case 365: sName = "Ultravision"; break;
  case 187: sName = "Unholy Aura"; break;
  case 188: sName = "Vampiric Touch"; break;
  case 189: sName = "Virtue"; break;
  case 190: sName = "Wail Of The Banshee"; break;
  case 191: sName = "Wall Of Fire"; break;
  case 373: sName = "War Cry"; break;
  case 192: sName = "Web"; break;
  case 193: sName = "Weird"; break;
  case 309: sName = "Wholeness Of Body"; break;
  case 320: sName = "Wild Shape"; break;
  case 405: sName = "Wild Shape, Badger"; break;
  case 404: sName = "Wild Shape, Boar"; break;
  case 401: sName = "Wild Shape, Brown Bear"; break;
  case 402: sName = "Wild Shape, Panther"; break;
  case 403: sName = "Wild Shape, Wolf"; break;
  case 194: sName = "Word Of Faith"; break;
  }

  /*

    switch(nSpellID)
    {
        case SPELL_LIGHT: return ("Light"); break;
        case SPELL_RESISTANCE: return ("Resistance"); break;
        case SPELL_GREASE: return ("Grease"); break;
        case SPELL_MAGE_ARMOR: return ("Mage Armor"); break;
        case SPELL_PROTECTION_FROM_EVIL: return ("Protection from Alignment"); break;
        case SPELL_SLEEP: return ("Sleep"); break;
        case SPELL_ENDURE_ELEMENTS: return ("Endure Elements"); break;
        // Level 2
        case SPELL_GHOSTLY_VISAGE: return ("Ghostly Visage"); break;
        case SPELL_INVISIBILITY: return ("Invisibility"); break;
        case SPELL_RESIST_ELEMENTS: return ("Resist Elements"); break;
        case SPELL_WEB: return ("Web"); break;
        // Level 3
       case SPELL_HASTE: return ("Haste"); break;
       case SPELL_MAGIC_CIRCLE_AGAINST_EVIL: return ("Magic Circle Against Alignment"); break;
       case SPELL_PROTECTION_FROM_ELEMENTS: return ("Protection from Elements"); break;
       case SPELL_STINKING_CLOUD: return ("Stinking Cloud"); break;
       // Level 4
       case SPELL_IMPROVED_INVISIBILITY: return ("Improved Invisibility"); break;
       case SPELL_MINOR_GLOBE_OF_INVULNERABILITY: return ("Minor Globe of Invulnerability"); break;
       case SPELL_POLYMORPH_SELF: return ("Polymorph Self"); break;
       case SPELL_STONESKIN: return ("Stoneskin"); break;
       // Level 5
       case SPELL_ELEMENTAL_SHIELD: return ("Elemental Shield"); break;
       case SPELL_ENERGY_BUFFER: return ("Energy Buffer"); break;
       case SPELL_LESSER_MIND_BLANK: return ("Lesser Mind Blank"); break;
       case SPELL_LESSER_SPELL_MANTLE: return ("Lesser Spell Mantle"); break;
       // Level 6
       case SPELL_ETHEREAL_VISAGE: return ("Ethereal Visage"); break;
       case SPELL_GLOBE_OF_INVULNERABILITY: return ("Globe of Invulnerability"); break;
       case SPELL_GREATER_STONESKIN: return ("Greater Stoneskin"); break;
       case SPELL_TENSERS_TRANSFORMATION: return ("Tenser's Transformation"); break;
       // Level 7
       case SPELL_PROTECTION_FROM_SPELLS: return ("Protection from Spells"); break;
       case SPELL_SHADOW_SHIELD: return ("Shadow Shield"); break;
       case SPELL_SPELL_MANTLE: return ("Spell Mantle"); break;
       // Level 8
       case SPELL_MIND_BLANK: return ("Mind Blank"); break;
       case SPELL_PREMONITION: return ("Premonition"); break;
       // Level 9
       case SPELL_GREATER_SPELL_MANTLE: return ("Greater Spell Mantle"); break;
       case SPELL_SHAPECHANGE: return ("Shapechange"); break;
    }
     return ("Unknown Spell");
    */
    return sName;
}


//:: void main() {}

//Dispel Magic: Name : Thing lost
//purple cyan purple
//Swamp Goul: Improved Evasion : Reflex Save vs. Fire : *failure* : (13+11 = 24 vs. DC: 25)

