// Script made 10/6 2005 by -Seeker- for the Alangara server.

// Purpose of script: Allowing characters to fish

// This script was inspired heavily from Nouny's fishing script
// but was rewritten from ground up, rather than having to
// customize the existing script heavily.

// Possible catches with this script: (d100)
// Lootbag  : 100
// Fish     :  20 - 99
// Bottle   :  17 - 19
// Skeleton :  15 - 16
// Redfish  :  12 - 14
// Rags     :   8 - 11
// Skull    :   5 -  7
// Stein    :   1 -  4

const int BREAKING_CHANCE = 0;   // The percentage that the fishing rod will break
                                 // with use - can be 0
const int XP_REWARD = 4;         // XP per attempt
const int XP_LEVEL_LIMIT = 35;   // The last level in which XP is gained from fishing
const int FISHING_DC = 18;       // The DC of catching anything
const float DELAY_LENGTH = 6.0f; // How long do the character sit down while fishing

void message( string msg, object oPC )
{
   FloatingTextStringOnCreature( msg, oPC, FALSE );
}

void fish( object oPC, object ofishingrod3 )
{
   // Make a fishing check for the player
   // Presently, that is a simple d20 roll without a modifier
   int iFishingCheck = d20();
   string sResult;
   if (iFishingCheck < FISHING_DC)
   {
      // It did not suceed
      sResult = "As much as the feeling of being pulled into the lake scares you, you manage to keep calm";
   }
   else
   {
      // Check for breakage
      int iBreak = d100();
      if ( iBreak <= BREAKING_CHANCE )
      {
         sResult = "You almost got one but it got away and your fishing rod broke!";
         DestroyObject(ofishingrod3, 0.0);
         PlaySound("as_na_branchsnp3");
      }
      else
      {
         // Find out what was caught
         // Catch list borrowed from Nouny ;-)

         int nCatch= d100();
         location lLoc = GetLocation( oPC );

         if (nCatch == 111) //PC gets a loot bag!
         {
            CreateObject(OBJECT_TYPE_PLACEABLE, "plc_lootbag2", lLoc, TRUE);
            sResult = "You caught a bag!";
         }

         if ( (nCatch >= 109) && (nCatch <= 110) ) //PC gets a fish
         {
            CreateItemOnObject("ke_it_msmlmisc20", oPC);
            // CreateObject(OBJECT_TYPE_ITEM, "ke_it_msmlmisc20", lLoc, TRUE);
            int nFishLong = d20() + 9; //The length of the fish
            string sFish = IntToString(nFishLong);
            sResult = "You caught a " + sFish + " inches fish!";
         }

         if ( (nCatch >= 107) && (nCatch <=108) ) //PC gets a bottle
         {
            CreateItemOnObject("nw_it_thnmisc001", oPC);
            // CreateObject(OBJECT_TYPE_ITEM, "nw_it_thnmisc001", lLoc, TRUE);
            sResult = "You caught an empty bottle!";
            }

         if ( (nCatch >= 105) && (nCatch <=106) ) //PC gets a skeleton and fight
         {
            CreateObject(OBJECT_TYPE_PLACEABLE, "nw_pl_skeleton", lLoc, TRUE);
            sResult = "You caught a skeleton!";
         }

         if ( (nCatch >= 103) && (nCatch <=104) ) //PC gets a redfish
         {
            CreateItemOnObject("redfish", oPC);
            // CreateObject(OBJECT_TYPE_ITEM, "redfish", lLoc, TRUE);
            sResult = "You caught a Redfish!";
         }

         if ( (nCatch >= 101) && (nCatch <=102) ) //PC gets rags
         {
            CreateItemOnObject("nw_it_msmlmisc21", oPC);
            // CreateObject(OBJECT_TYPE_ITEM, "nw_it_msmlmisc21", lLoc, TRUE);
            sResult = "You caught some smelly rags!";
         }

         if ( (nCatch >= 86) && (nCatch <=100) ) //PC gets a Soulreaper
         {
           CreateObject(OBJECT_TYPE_CREATURE, "soulreaper1", lLoc, TRUE);
            sResult = "You have awoken a Soulreaper";
         }

         if ( (nCatch >= 01) && (nCatch <=85) ) //PC gets a lost soul
         {
            CreateObject(OBJECT_TYPE_CREATURE, "lostsoul1", lLoc, TRUE);
            sResult = "A lost soul escapes the lake, and attacks you";
         }
      }
   }
   message ( sResult, oPC );

   // Award XP for fishing attempt
   int iLevel = GetHitDice( oPC );
   if ( iLevel <= XP_LEVEL_LIMIT )
   {
      GiveXPToCreature( oPC, XP_REWARD );
   }

}

void main()
{
   object oPC = GetClickingObject();
   if (!GetIsPC(oPC)) return;

   object oHasfishingrod3 = GetItemPossessedBy(oPC, "fishingrod3");
   location lLoc = GetLocation(oPC);

   if (oHasfishingrod3 == OBJECT_INVALID)
   {
      message("You cannot fish without the strange rod.", oPC);
      AssignCommand(oPC, ActionPlayAnimation(ANIMATION_FIREFORGET_PAUSE_SCRATCH_HEAD , 1.0, 2.0));
   }
   else
   {
      // Make sure that Fishing Rod is equipped
      object oEquipped = GetItemInSlot( INVENTORY_SLOT_RIGHTHAND, oPC );
      if ( GetTag( oEquipped ) != "fishingrod3" )
      {
         message ("You must equip your strange rod, before starting to fish.", oPC );
         AssignCommand(oPC, ActionPlayAnimation(ANIMATION_FIREFORGET_PAUSE_SCRATCH_HEAD , 1.0, 2.0));
      }
      else
      {
         // Play "fishing animation" and sound
         ClearAllActions();
         AssignCommand( oPC, ActionPlayAnimation (ANIMATION_LOOPING_SIT_CROSS, 1.0f, DELAY_LENGTH) );
         PlaySound("as_na_splash2");
         DelayCommand (0.1f, SetCommandable (FALSE, oPC));
         DelayCommand (DELAY_LENGTH, SetCommandable (TRUE, oPC));
         float fDelay = DELAY_LENGTH + 0.1f;
         DelayCommand (fDelay, fish( oPC, oHasfishingrod3) );
      }
   }



}
