//::///////////////////////////////////////////////
//:: tk_listener_c4
//::
//:: OnConversation event handler for a dedicated listener.
//:://////////////////////////////////////////////
/*
    Reports what was heard, then resumes the conversation.
*/
//:://////////////////////////////////////////////
//:: Created By: The Krit
//:: Created On: May 21, 2007
//:://////////////////////////////////////////////


void main()
{
    // Abort if this was not a matched string.
    if ( GetListenPatternNumber() == -1 )
        return;

    // Abort if we did not hear the right creature.
    object oTarget = GetLocalObject(OBJECT_SELF, "ListenTo");
    if ( oTarget != OBJECT_INVALID  &&  GetLastSpeaker() != oTarget )
        return;

    // Record what was heard.
    object oBoss = GetLocalObject(OBJECT_SELF, "EmployedBy");
    // For generality without too much complication, record the last matched substring.
    SetLocalString(oBoss, GetLocalString(OBJECT_SELF, "RecordAs"),
                   GetMatchedSubstring(GetMatchedSubstringsCount() - 1));

    // We have accomplished our task.
    SetListening(OBJECT_SELF, FALSE);

    // Resume the conversation.
    AssignCommand(oBoss, ActionResumeConversation());
}

