//File name: zep_inc_monster
//Description/Purpose: This file is an include file laying out
//          various constants and the like that may be toggled
//          to tweak CEP monster behavior.
//      Various monster AI and other scripts in the CEP will
//      reference constants contained herein.  Highly complex
//      monsters may have their own, separate include files
//      as well.
//      This file also contains the constants for appearances.
//Author: Loki Hakanin

//Following line is Demilich includes (1.02 version)
#include "zep_inc_demi"


//***************************************************
//************   Begin Appearances Constants*********
//***************************************************

const int APPEARANCE_TYPE_ZEP_WEMIC = 1000 ;
const int APPEARANCE_TYPE_ZEP_TWIG_BLIGHT = 1001 ;
const int APPEARANCE_TYPE_ZEP_BROWNIE = 1002 ;
const int APPEARANCE_TYPE_ZEP_SATYR = 1003 ;
const int APPEARANCE_TYPE_ZEP_SATYR_LARGE = 1004 ;
const int APPEARANCE_TYPE_ZEP_CATTLE_CALF_DARK = 1005 ;
const int APPEARANCE_TYPE_ZEP_CATTLE_CALF_BROWN = 1006 ;
const int APPEARANCE_TYPE_ZEP_BUFFALO_CALF = 1007 ;
const int APPEARANCE_TYPE_ZEP_CATTLE_LONGHORN = 1008 ;
const int APPEARANCE_TYPE_ZEP_BUFFALO_A = 1009 ;
const int APPEARANCE_TYPE_ZEP_BUFFALO_B = 1010 ;
const int APPEARANCE_TYPE_ZEP_BUFFALO_C = 1011 ;
const int APPEARANCE_TYPE_ZEP_CATTLE_ROTHE = 1012 ;
const int APPEARANCE_TYPE_ZEP_CATTLE_BLACK_ANGUS = 1013 ;
const int APPEARANCE_TYPE_ZEP_CATTLE_BROWN_ANGUS = 1014 ;
const int APPEARANCE_TYPE_ZEP_BISON = 1015 ;
const int APPEARANCE_TYPE_ZEP_BISON_ANTIQUUS = 1016 ;
const int APPEARANCE_TYPE_ZEP_CATTLE_BRAHMAN = 1017 ;
const int APPEARANCE_TYPE_ZEP_CATTLE_FIGHTING = 1018 ;
const int APPEARANCE_TYPE_ZEP_CATTLE_HIGHLAND = 1019 ;
const int APPEARANCE_TYPE_ZEP_CATTLE_HOLSTEIN = 1020 ;
const int APPEARANCE_TYPE_ZEP_PACK_BADGER = 1021 ;
const int APPEARANCE_TYPE_ZEP_PACK_OX = 1022 ;
const int APPEARANCE_TYPE_ZEP_OX_PLOW = 1023 ;
const int APPEARANCE_TYPE_ZEP_OX_PACK = 1024 ;
const int APPEARANCE_TYPE_ZEP_SWINE_PIG = 1025 ;
const int APPEARANCE_TYPE_ZEP_SWINE_HOG = 1026 ;
const int APPEARANCE_TYPE_ZEP_SWINE_PECCARY = 1027 ;
const int APPEARANCE_TYPE_ZEP_SWINE_BABIRUSA = 1028 ;
const int APPEARANCE_TYPE_ZEP_SWINE_POTBELLY = 1029 ;
const int APPEARANCE_TYPE_ZEP_ARMOR_STAND = 1030 ;
const int APPEARANCE_TYPE_ZEP_DRACOLICH_B = 1031 ;
const int APPEARANCE_TYPE_ZEP_RUST_MONSTER = 1044 ;
const int APPEARANCE_TYPE_ZEP_OWLBEAR = 1045 ;
const int APPEARANCE_TYPE_ZEP_BEHOLDER_B = 1046 ;
const int APPEARANCE_TYPE_ZEP_SCARECROW = 1047 ;
const int APPEARANCE_TYPE_ZEP_GHOUL_ICE = 1048 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_SMALL = 1049 ;
const int APPEARANCE_TYPE_ZEP_STIRGE_CAVE = 1050 ;
const int APPEARANCE_TYPE_ZEP_ILLITHID = 1052 ;
const int APPEARANCE_TYPE_ZEP_SHRIEKER = 1053 ;
const int APPEARANCE_TYPE_ZEP_XORN = 1054 ;
const int APPEARANCE_TYPE_ZEP_MYCONID = 1055 ;
const int APPEARANCE_TYPE_ZEP_MYCONID_SPROUT = 1056 ;
const int APPEARANCE_TYPE_ZEP_MYCONID_ELDER = 1057 ;
const int APPEARANCE_TYPE_ZEP_TROLL_B = 1058 ;
const int APPEARANCE_TYPE_ZEP_VEGEPYGMY = 1060 ;
const int APPEARANCE_TYPE_ZEP_THORNY = 1061 ;
const int APPEARANCE_TYPE_ZEP_VEGEPYGMY_THORNY_RIDER_T = 1062 ;
const int APPEARANCE_TYPE_ZEP_VEGEPYGMY_THORNY_RIDER = 1063 ;
const int APPEARANCE_TYPE_ZEP_VEGEPYGMY_THORNY_RIDER_V = 1064 ;
const int APPEARANCE_TYPE_ZEP_CYCLOPS = 1065 ;
const int APPEARANCE_TYPE_ZEP_ELF_BLACKROSE_MALE = 1067 ;
const int APPEARANCE_TYPE_ZEP_ELF_BLACKROSE_FEMALE = 1068 ;
const int APPEARANCE_TYPE_ZEP_FLYING_EYE = 1073 ;
const int APPEARANCE_TYPE_ZEP_MARILITH_DEMONIC = 1074 ;
const int APPEARANCE_TYPE_ZEP_MARILITH_HUMANOID = 1075 ;
const int APPEARANCE_TYPE_ZEP_MARILITH_BLACKGUARD = 1076 ;
const int APPEARANCE_TYPE_ZEP_ERINYES = 1077 ;
const int APPEARANCE_TYPE_ZEP_PLANETOUCHED_FEYRI = 1088 ;
const int APPEARANCE_TYPE_ZEP_SUCCUBUS_2ND_ED = 1089 ;
const int APPEARANCE_TYPE_ZEP_SHADE_HOODED = 1090 ;
const int APPEARANCE_TYPE_ZEP_SHADE = 1091 ;
const int APPEARANCE_TYPE_ZEP_SUCCUBUS__PG_RATED = 1093 ;
const int APPEARANCE_TYPE_ZEP_CORNUGON_B = 1094 ;
const int APPEARANCE_TYPE_ZEP_WRAITH_HOODED_1 = 1095 ;
const int APPEARANCE_TYPE_ZEP_WRAITH_HOODED_2 = 1096 ;
const int APPEARANCE_TYPE_ZEP_DEVIL_B = 1097 ;
const int APPEARANCE_TYPE_ZEP_GELUGON = 1098 ;
const int APPEARANCE_TYPE_ZEP_VISAGE = 1099 ;
const int APPEARANCE_TYPE_ZEP_VISAGE_GREATER = 1100 ;
const int APPEARANCE_TYPE_ZEP_DEMON_VORLAN = 1101 ;
const int APPEARANCE_TYPE_ZEP_HAMATULA = 1102 ;
const int APPEARANCE_TYPE_ZEP_BARGHEST = 1103 ;
const int APPEARANCE_TYPE_ZEP_BELKER = 1104 ;
const int APPEARANCE_TYPE_ZEP_SALAMANDER_AVERAGE = 1106 ;
const int APPEARANCE_TYPE_ZEP_SALAMANDER_FLAME_BRO = 1107 ;
const int APPEARANCE_TYPE_ZEP_SALAMANDER_NOBLE = 1108 ;
const int APPEARANCE_TYPE_ZEP_AZER_MALE_B = 1109 ;
const int APPEARANCE_TYPE_ZEP_AZER_FEMALE_B = 1110 ;
const int APPEARANCE_TYPE_ZEP_RAKSHASA_WOLF_FEMALE = 1111 ;
const int APPEARANCE_TYPE_ZEP_RAKSHASA_BEAR_FEMALE = 1112 ;
const int APPEARANCE_TYPE_ZEP_LUPINAL_MALE_1 = 1113 ;
const int APPEARANCE_TYPE_ZEP_LUPINAL_MALE_2 = 1114 ;
const int APPEARANCE_TYPE_ZEP_LUPINAL_MALE_3 = 1115 ;
const int APPEARANCE_TYPE_ZEP_LUPINAL_MALE_4 = 1116 ;
const int APPEARANCE_TYPE_ZEP_LUPINAL_FEMALE_1 = 1117 ;
const int APPEARANCE_TYPE_ZEP_LUPINAL_FEMALE_2 = 1118 ;
const int APPEARANCE_TYPE_ZEP_LUPINAL_FEMALE_3 = 1119 ;
const int APPEARANCE_TYPE_ZEP_LUPINAL_FEMALE_4 = 1120 ;
const int APPEARANCE_TYPE_ZEP_MANTICORE_B = 1121 ;
const int APPEARANCE_TYPE_ZEP_SPHINX_ANDRO = 1122 ;
const int APPEARANCE_TYPE_ZEP_SPHINX_HIERACO = 1123 ;
const int APPEARANCE_TYPE_ZEP_SPHINX_GYNO = 1124 ;
const int APPEARANCE_TYPE_ZEP_ORC_FAERUN_CHIEF = 1132 ;
const int APPEARANCE_TYPE_ZEP_ORC_FAERUN = 1133 ;
const int APPEARANCE_TYPE_ZEP_ORC_D = 1134 ;
const int APPEARANCE_TYPE_ZEP_ORC_E = 1135 ;
const int APPEARANCE_TYPE_ZEP_ORC_F = 1136 ;
const int APPEARANCE_TYPE_ZEP_ORC_MERCENARY = 1137 ;
const int APPEARANCE_TYPE_ZEP_ORC_SNOW = 1138 ;
const int APPEARANCE_TYPE_ZEP_ORC_SNOW_CHIEFTAN = 1139 ;
const int APPEARANCE_TYPE_ZEP_ORC_SNOW_SHAMAN = 1140 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_BONE_WIZARD = 1141 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_SPIDER_RIDER = 1142 ;
const int APPEARANCE_TYPE_ZEP_ORC_URAK_HAI_A = 1143 ;
const int APPEARANCE_TYPE_ZEP_ORC_URAK_HAI_B = 1144 ;
const int APPEARANCE_TYPE_ZEP_ORC_URAK_CAPTAIN = 1145 ;
const int APPEARANCE_TYPE_ZEP_ORC_URAK_WORG_TRAINER = 1146 ;
const int APPEARANCE_TYPE_ZEP_ORC_URAK_HAI_C = 1147 ;
const int APPEARANCE_TYPE_ZEP_ORC_BLOODGUAR = 1148 ;
const int APPEARANCE_TYPE_ZEP_OGRILLION_TAN_1 = 1149 ;
const int APPEARANCE_TYPE_ZEP_OGRILLION_TAN_2 = 1150 ;
const int APPEARANCE_TYPE_ZEP_OGRILLION_DULL_1 = 1151 ;
const int APPEARANCE_TYPE_ZEP_OGRILLION_DULL_2 = 1152 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_WORG_RIDER = 1153 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_WORG_RIDER_W = 1154 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_WORG_RIDER_G = 1155 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_FROST_CHIEF = 1156 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_FROST_SHAMAN = 1157 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_FROST = 1158 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_CAVE = 1159 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_CAVE_ARCHER = 1160 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_CAVE_BERKSERK = 1161 ;
const int APPEARANCE_TYPE_ZEP_GOBLIN_CAVE_SHAMAN = 1162 ;
const int APPEARANCE_TYPE_ZEP_KOBOLD_ICE_NOBLE = 1163 ;
const int APPEARANCE_TYPE_ZEP_KOBOLD_ICE_WIZARD = 1164 ;
const int APPEARANCE_TYPE_ZEP_KOBOLD_ICE = 1165 ;
const int APPEARANCE_TYPE_ZEP_SPIDER_BLOODBACK = 1168 ;
const int APPEARANCE_TYPE_ZEP_ANT_GIANT = 1169 ;
const int APPEARANCE_TYPE_ZEP_ANT_GIANT_FIRE = 1170 ;
const int APPEARANCE_TYPE_ZEP_BUGS = 1171 ;
const int APPEARANCE_TYPE_ZEP_BUGS_LARGE = 1172 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_HUGE = 1173 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_HUGE_A = 1174 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_HUGE_B = 1175 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_HUGE_C = 1176 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_GIANT = 1177 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_GIANT_A = 1178 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_GIANT_B = 1179 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_GIANT_C = 1180 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_SMALL = 1181 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_SMALL_A = 1182 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_SMALL_B = 1183 ;
const int APPEARANCE_TYPE_ZEP_SCORPION_SMALL_C = 1184 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_SLICER_FINE = 1185 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_SLICER_TINY = 1186 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_SLICER_HUGE = 1187 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_FIRE_FINE = 1188 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_FIRE_TINY = 1189 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_FIRE_HUGE = 1190 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_STAG_FINE = 1191 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_STAG_TINY = 1192 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_STAG_HUGE = 1193 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_STINK_FINE = 1194 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_STINK_TINY = 1195 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_STINK_HUGE = 1196 ;
const int APPEARANCE_TYPE_ZEP_SPIDERFIEND_KAKKUU = 1197 ;
const int APPEARANCE_TYPE_ZEP_SPIDERFIEND_SPITHRIKU = 1198 ;
const int APPEARANCE_TYPE_ZEP_SPIDERFIEND_PHISARAZU = 1199 ;
const int APPEARANCE_TYPE_ZEP_SPIDERFIEND_LYCOSIDILTH = 1200 ;
const int APPEARANCE_TYPE_ZEP_SPIDERFIEND_RAKLUPIS = 1201 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_MALE_A = 1202 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_MALE_B = 1203 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_MALE_C = 1204 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_MALE_D = 1205 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_MALE_E = 1206 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_FEMALE_A = 1207 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_FEMALE_B = 1208 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_FEMALE_C = 1209 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_FEMALE_D = 1210 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_ARMOR_A = 1211 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_ARMOR_B = 1212 ;
const int APPEARANCE_TYPE_ZEP_DRIDER_ARMOR_C = 1213 ;
const int APPEARANCE_TYPE_ZEP_LOLTH = 1214 ;
const int APPEARANCE_TYPE_ZEP_DOPPELGANGER = 1215 ;
const int APPEARANCE_TYPE_ZEP_MECHANON_SPIKER = 1216 ;
const int APPEARANCE_TYPE_ZEP_MECHANON_SPIDER = 1217 ;
const int APPEARANCE_TYPE_ZEP_MECHANON_CUTTER = 1218 ;
const int APPEARANCE_TYPE_ZEP_ILLITHID_SCIENTIST = 1219 ;
const int APPEARANCE_TYPE_ZEP_ILLITHID_BIOLOGIST = 1220 ;
const int APPEARANCE_TYPE_ZEP_ILLITHID_3E = 1221 ;
const int APPEARANCE_TYPE_ZEP_ILLITHID_MURRAY = 1222 ;
const int APPEARANCE_TYPE_ZEP_ILLITHID_KID = 1223 ;
const int APPEARANCE_TYPE_ZEP_ILLITHID_BIOLOGIST_2 = 1224 ;
const int APPEARANCE_TYPE_ZEP_VIPER_HUGE_FOREST = 1225 ;
const int APPEARANCE_TYPE_ZEP_VIPER_MEDIUM_FOREST = 1226 ;
const int APPEARANCE_TYPE_ZEP_VIPER_TINY_FOREST = 1227 ;
const int APPEARANCE_TYPE_ZEP_VIPER_HUGE_DESERT = 1228 ;
const int APPEARANCE_TYPE_ZEP_VIPER_MEDIUM_DESERT = 1229 ;
const int APPEARANCE_TYPE_ZEP_VIPER_TINY_DESERT = 1230 ;
const int APPEARANCE_TYPE_ZEP_VIPER_HUGE_SWAMP = 1231 ;
const int APPEARANCE_TYPE_ZEP_VIPER_MEDIUM_SWAMP = 1232 ;
const int APPEARANCE_TYPE_ZEP_VIPER_TINY_SWAMP = 1233 ;
const int APPEARANCE_TYPE_ZEP_VIPER_HUGE_JUNGLE = 1234 ;
const int APPEARANCE_TYPE_ZEP_VIPER_MEDIUM_JUNGLE = 1235 ;
const int APPEARANCE_TYPE_ZEP_VIPER_TINY_JUNGLE = 1236 ;
const int APPEARANCE_TYPE_ZEP_ANT_GIANT_SOLDIER = 1243 ;
const int APPEARANCE_TYPE_ZEP_ANT_GIANT_GUARD = 1244 ;
const int APPEARANCE_TYPE_ZEP_ANT_GIANT_QUEEN = 1245 ;
const int APPEARANCE_TYPE_ZEP_ANT_GIANT_LARVA = 1246 ;
const int APPEARANCE_TYPE_ZEP_ANT_GIANT_HIVEQUEEN = 1247 ;
const int APPEARANCE_TYPE_ZEP_SPIDER_REDBACK = 1248 ;
const int APPEARANCE_TYPE_ZEP_PACK_BEAR = 1249 ;
const int APPEARANCE_TYPE_ZEP_PACK_BEETLE = 1250 ;
const int APPEARANCE_TYPE_ZEP_PACK_BOAR = 1251 ;
const int APPEARANCE_TYPE_ZEP_PACK_PENGUIN = 1252 ;
const int APPEARANCE_TYPE_ZEP_DEMON_BEBILITH_B = 1253 ;
const int APPEARANCE_TYPE_ZEP_COW_2 = 1255 ;
const int APPEARANCE_TYPE_ZEP_SPIDER_WRAITH_B = 1256 ;
const int APPEARANCE_TYPE_ZEP_MINOGON_B = 1257 ;
const int APPEARANCE_TYPE_ZEP_CAT_COUGAR = 1258 ;
const int APPEARANCE_TYPE_ZEP_VAMPIRIC_MIST_2 = 1259 ;
const int APPEARANCE_TYPE_ZEP_SLAAD_GREEN_B = 1261 ;
const int APPEARANCE_TYPE_ZEP_BARGHEST_GREATER = 1262 ;
const int APPEARANCE_TYPE_ZEP_BEETLE_BOMBARDIER = 1263 ;
const int APPEARANCE_TYPE_ZEP_CHILD_MALE_1 = 1265 ;
const int APPEARANCE_TYPE_ZEP_CHILD_FEMALE_1 = 1266 ;
const int APPEARANCE_TYPE_ZEP_CHILD_MALE_2 = 1267 ;
const int APPEARANCE_TYPE_ZEP_CHILD_FEMALE_2 = 1268 ;
const int APPEARANCE_TYPE_ZEP_CHILD_MALE_3 = 1269 ;
const int APPEARANCE_TYPE_ZEP_CHILD_FEMALE_3 = 1270 ;
const int APPEARANCE_TYPE_ZEP_CHILD_MALE_4 = 1271 ;
const int APPEARANCE_TYPE_ZEP_CHILD_FEMALE_4 = 1272 ;
const int APPEARANCE_TYPE_ZEP_CHILD_MALE_5 = 1273 ;
const int APPEARANCE_TYPE_ZEP_CHILD_FEMALE_5 = 1274 ;
const int APPEARANCE_TYPE_ZEP_EAGLE = 1275 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_DWARF = 1277 ;
const int APPEARANCE_TYPE_ZEP_BUGBEAR_ARCTIC = 1278 ;
const int APPEARANCE_TYPE_ZEP_BUGBEAR_ARCTIC_SHAMAN = 1279 ;
const int APPEARANCE_TYPE_ZEP_BUGBEAR_ARCTIC_CHIEF = 1280 ;
const int APPEARANCE_TYPE_ZEP_BAT_BATTLE = 1281 ;
const int APPEARANCE_TYPE_ZEP_BAT_BONE = 1282 ;
const int APPEARANCE_TYPE_ZEP_ETHER_SCARAB = 1283 ;
const int APPEARANCE_TYPE_ZEP_SPIDER_ICE = 1284 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_RED_EYES = 1285 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_FLAMING = 1286 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_GREEN = 1287 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_PURPLE = 1288 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_YELLOW = 1289 ;
const int APPEARANCE_TYPE_ZEP_WENDIGO = 1290 ;
const int APPEARANCE_TYPE_ZEP_BALROG = 1291 ;
const int APPEARANCE_TYPE_ZEP_BEAR_SUN = 1292 ;
const int APPEARANCE_TYPE_ZEP_BEAR_SPECTACLED = 1293 ;
const int APPEARANCE_TYPE_ZEP_BEAR_SLOTH = 1294 ;
const int APPEARANCE_TYPE_ZEP_BEAR_PANDA = 1295 ;
const int APPEARANCE_TYPE_ZEP_TROLLOC_BOAR = 1296 ;
const int APPEARANCE_TYPE_ZEP_TROLLOC_GOAT = 1297 ;
const int APPEARANCE_TYPE_ZEP_TROLLOC_HAWK = 1298 ;
const int APPEARANCE_TYPE_ZEP_CAT_TIGER = 1299 ;
const int APPEARANCE_TYPE_ZEP_CAT_WHITE_TIGER = 1300 ;
const int APPEARANCE_TYPE_ZEP_CAT_SNOW_LEOPARD = 1302 ;
const int APPEARANCE_TYPE_ZEP_CAT_CLOUDED_LEOPARD = 1303 ;
const int APPEARANCE_TYPE_ZEP_BLADELING = 1304 ;
const int APPEARANCE_TYPE_ZEP_HUMAN_NPC_KING = 1305 ;
const int APPEARANCE_TYPE_ZEP_HUMAN_CLERIC_OF_TYR = 1306 ;
const int APPEARANCE_TYPE_ZEP_DEMILICH_B = 1307 ;
const int APPEARANCE_TYPE_ZEP_MOUSE = 1308 ;
const int APPEARANCE_TYPE_ZEP_SPIDERLING = 1311 ;
const int APPEARANCE_TYPE_ZEP_SPIDERLING_GIANT = 1312 ;
const int APPEARANCE_TYPE_ZEP_SPIDERLING_DIRE = 1313 ;
const int APPEARANCE_TYPE_ZEP_SPIDERLING_SWORD = 1314 ;
const int APPEARANCE_TYPE_ZEP_SPIDERLING_PHASE = 1315 ;
const int APPEARANCE_TYPE_ZEP_SKULK_FEMALE = 1316 ;
const int APPEARANCE_TYPE_ZEP_SKULK_MALE = 1317 ;
const int APPEARANCE_TYPE_ZEP_HALF_DRAGON_FIEND = 1318 ;
const int APPEARANCE_TYPE_ZEP_CYCLOPS_ARMORED = 1319 ;
const int APPEARANCE_TYPE_ZEP_ERINYES_B = 1324 ;
const int APPEARANCE_TYPE_ZEP_VECNA = 1325 ;
const int APPEARANCE_TYPE_ZEP_HYENA_SPOTTED = 1326 ;
const int APPEARANCE_TYPE_ZEP_HYENA_STRIPED = 1327 ;
const int APPEARANCE_TYPE_ZEP_RACCOON = 1328 ;
const int APPEARANCE_TYPE_ZEP_RED_PANDA = 1329 ;
const int APPEARANCE_TYPE_ZEP_RINGTAIL = 1330 ;
const int APPEARANCE_TYPE_ZEP_ANTELOPE_BROWN = 1332 ;
const int APPEARANCE_TYPE_ZEP_ANTELOPE_BLACK = 1333 ;
const int APPEARANCE_TYPE_ZEP_GAZELLE = 1334 ;
const int APPEARANCE_TYPE_ZEP_OTTER = 1335 ;
const int APPEARANCE_TYPE_ZEP_WEASEL = 1336 ;
const int APPEARANCE_TYPE_ZEP_WOLVERINE = 1337 ;
const int APPEARANCE_TYPE_ZEP_SKUNK = 1338 ;
const int APPEARANCE_TYPE_ZEP_MINK = 1339 ;
const int APPEARANCE_TYPE_ZEP_FISHER = 1340 ;
const int APPEARANCE_TYPE_ZEP_FERRET = 1341 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_AIR_L = 1342 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_AIR_M = 1343 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_AIR_S = 1344 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_SMOKE_L = 1345 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_SMOKE_M = 1346 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_SMOKE_S = 1347 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_MAGMA_L = 1348 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_MAGMA_M = 1349 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_MAGMA_S = 1350 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_OOZE_L = 1351 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_OOZE_M = 1352 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_OOZE_S = 1353 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_WATER_L = 1354 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_WATER_M = 1355 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_WATER_S = 1356 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_FIRE_L = 1357 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_FIRE_M = 1358 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_FIRE_S = 1359 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_EARTH_L = 1360 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_EARTH_M = 1361 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_EARTH_S = 1362 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_ICE_L = 1363 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_ICE_M = 1364 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_ICE_S = 1365 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_RADIANCE_L = 1366 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_RADIANCE_M = 1367 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_RADIANCE_S = 1368 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_MINERAL_L = 1369 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_MINERAL_M = 1370 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_MINERAL_S = 1371 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_STEAM_L = 1372 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_STEAM_M = 1373 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_STEAM_S = 1374 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_LIGHTNING_L = 1375 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_LIGHTNING_M = 1376 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_LIGHTNING_S = 1377 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_SALT_L = 1378 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_SALT_M = 1379 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_SALT_S = 1380 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_DUST_L = 1381 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_DUST_M = 1382 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_DUST_S = 1383 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_ASH_L = 1384 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_ASH_M = 1385 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_ASH_S = 1386 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_VACUUM_L = 1387 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_VACUUM_M = 1388 ;
const int APPEARANCE_TYPE_ZEP_ELEMENTAL_VACUUM_S = 1389 ;
const int APPEARANCE_TYPE_ZEP_DOG_COOSHEE_FEMALE = 1390 ;
const int APPEARANCE_TYPE_ZEP_DOG_COOSHEE_MALE = 1391 ;
const int APPEARANCE_TYPE_ZEP_DOG_DALMATIAN = 1392 ;
const int APPEARANCE_TYPE_ZEP_DOG_DOBERMAN = 1393 ;
const int APPEARANCE_TYPE_ZEP_DOG_HUSKY = 1394 ;
const int APPEARANCE_TYPE_ZEP_DOG_MALAMUTE = 1395 ;
const int APPEARANCE_TYPE_ZEP_DOG_MASTIFF = 1396 ;
const int APPEARANCE_TYPE_ZEP_DOG_TERRIER = 1397 ;
const int APPEARANCE_TYPE_ZEP_DOG_YELLOW = 1398 ;
const int APPEARANCE_TYPE_ZEP_PUPPY_DALMATIAN = 1399 ;
const int APPEARANCE_TYPE_ZEP_PUPPY_COOSHEE = 1400 ;
const int APPEARANCE_TYPE_ZEP_PUPPY_DOBERMAN = 1401 ;
const int APPEARANCE_TYPE_ZEP_PUPPY_HUSKY = 1402 ;
const int APPEARANCE_TYPE_ZEP_PUPPY_MASTIFF = 1403 ;
const int APPEARANCE_TYPE_ZEP_PUPPY_TERRIER = 1404 ;
const int APPEARANCE_TYPE_ZEP_PUPPY_YELLOW = 1405 ;
const int APPEARANCE_TYPE_ZEP_CAT_BLACK = 1406 ;
const int APPEARANCE_TYPE_ZEP_CAT_BLACK_AND_WHITE = 1407 ;
const int APPEARANCE_TYPE_ZEP_CAT_BOBTAIL = 1408 ;
const int APPEARANCE_TYPE_ZEP_CAT_WHITE = 1409 ;
const int APPEARANCE_TYPE_ZEP_KITTEN_BLK_N_WHT = 1410 ;
const int APPEARANCE_TYPE_ZEP_KITTEN_WHITE = 1411 ;
const int APPEARANCE_TYPE_ZEP_GLABREZU = 1418 ;
const int APPEARANCE_TYPE_ZEP_ANIMATED_WHEEL = 1421 ;
const int APPEARANCE_TYPE_ZEP_ANIMATED_TABLE = 1422 ;
const int APPEARANCE_TYPE_ZEP_ANIMATED_CHEST = 1424 ;
const int APPEARANCE_TYPE_ZEP_ANIMATED_TOME = 1425 ;
const int APPEARANCE_TYPE_ZEP_ANIMATED_CHEST_FLYING = 1426 ;
const int APPEARANCE_TYPE_ZEP_CRAB_GIANT_BLUE = 1427 ;
const int APPEARANCE_TYPE_ZEP_CRAB_BLUE = 1428 ;
const int APPEARANCE_TYPE_ZEP_CRAB_GIANT = 1429 ;
const int APPEARANCE_TYPE_ZEP_CRAB = 1430 ;
const int APPEARANCE_TYPE_ZEP_STIRGE_A = 1431 ;
const int APPEARANCE_TYPE_ZEP_STIRGE_B = 1432 ;
const int APPEARANCE_TYPE_ZEP_DEMON_BEBILITH_C = 1433 ;
const int APPEARANCE_TYPE_ZEP_CORNUGON_A = 1434 ;
const int APPEARANCE_TYPE_ZEP_FLYING_BOOK_A = 1435 ;
const int APPEARANCE_TYPE_ZEP_FLYING_BOOK_B = 1436 ;
const int APPEARANCE_TYPE_ZEP_FLYING_BOOK_C = 1437 ;
const int APPEARANCE_TYPE_ZEP_ZOMBIE_PIRATE_1 = 1439 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_PIRATE_1 = 1440 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_PIRATE_2 = 1441 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_PIRATE_3 = 1442 ;
const int APPEARANCE_TYPE_ZEP_ZOMBIE_PIRATE_2 = 1443 ;
const int APPEARANCE_TYPE_ZEP_ZOMBIE_PIRATE_3 = 1444 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_PIRATE_4 = 1445 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_PIRATE_5 = 1446 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_PIRATE_6 = 1447 ;
const int APPEARANCE_TYPE_ZEP_ZOMBIE_PIRATE_4 = 1448 ;
const int APPEARANCE_TYPE_ZEP_GHOST_PIRATE = 1449 ;
const int APPEARANCE_TYPE_ZEP_SKELETON_OGRE = 1451 ;
const int APPEARANCE_TYPE_ZEP_JELLY_MUSTARD = 1453 ;
const int APPEARANCE_TYPE_ZEP_JELLY_MUSTARD_MEDIUM = 1454 ;
const int APPEARANCE_TYPE_ZEP_JELLY_MUSTARD_LARGE = 1455 ;
const int APPEARANCE_TYPE_ZEP_JELLY_OCHRE = 1456 ;
const int APPEARANCE_TYPE_ZEP_JELLY_OCHRE_MEDIUM = 1457 ;
const int APPEARANCE_TYPE_ZEP_JELLY_OCHRE_LARGE = 1458 ;
const int APPEARANCE_TYPE_ZEP_OOZE_CRYSTAL = 1459 ;
const int APPEARANCE_TYPE_ZEP_OOZE_CRYSTAL_MEDIUM = 1460 ;
const int APPEARANCE_TYPE_ZEP_OOZE_CRYSTAL_LARGE = 1461 ;
const int APPEARANCE_TYPE_ZEP_OOZE_GRAY = 1462 ;
const int APPEARANCE_TYPE_ZEP_OOZE_GRAY_MEDIUM = 1463 ;
const int APPEARANCE_TYPE_ZEP_OOZE_GRAY_LARGE = 1464 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_BLACK = 1465 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_BLACK_MEDIUM = 1466 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_BLACK_LARGE = 1467 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_BROWN = 1468 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_BROWN_MEDIUM = 1469 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_BROWN_LARGE = 1470 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_DUN = 1471 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_DUN_MEDIUM = 1472 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_DUN_LARGE = 1473 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_WHITE = 1474 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_WHITE_MEDIUM = 1475 ;
const int APPEARANCE_TYPE_ZEP_PUDDING_WHITE_LARGE = 1476 ;
const int APPEARANCE_TYPE_ZEP_SLIME_GREEN = 1477 ;
const int APPEARANCE_TYPE_ZEP_SLIME_GREEN_MEDIUM = 1478 ;
const int APPEARANCE_TYPE_ZEP_SLIME_GREEN_LARGE = 1479 ;
const int APPEARANCE_TYPE_ZEP_SLIME_OLIVE = 1480 ;
const int APPEARANCE_TYPE_ZEP_SLIME_OLIVE_MEDIUM = 1481 ;
const int APPEARANCE_TYPE_ZEP_SLIME_OLIVE_LARGE = 1482 ;
const int APPEARANCE_TYPE_ZEP_SLITHERING_TRACKER = 1483 ;
const int APPEARANCE_TYPE_ZEP_SLITHERING_TRACKER_MEDIUM = 1484 ;
const int APPEARANCE_TYPE_ZEP_SLITHERING_TRACKER_LARGE = 1485 ;
const int APPEARANCE_TYPE_ZEP_GOLEM_RUBY = 1486 ;
const int APPEARANCE_TYPE_ZEP_GOLEM_EMERALD = 1487 ;
const int APPEARANCE_TYPE_ZEP_GOLEM_CITRINE = 1488 ;
const int APPEARANCE_TYPE_ZEP_GOLEM_SAPPHIRE = 1489 ;
const int APPEARANCE_TYPE_ZEP_GOLEM_AMETHYST = 1490 ;
const int APPEARANCE_TYPE_ZEP_GOLEM_OBSIDIAN = 1491 ;
const int APPEARANCE_TYPE_ZEP_TREANT = 1492 ;
const int APPEARANCE_TYPE_ZEP_WEREBAT = 1493 ;
const int APPEARANCE_TYPE_ZEP_WASP_GIANT = 1494 ;
const int APPEARANCE_TYPE_ZEP_ERINYES3 = 1495 ;
const int APPEARANCE_TYPE_ZEP_ASSASSIN_VINE_H = 1496 ;
const int APPEARANCE_TYPE_ZEP_ASSASSIN_VINE_V = 1497 ;
const int APPEARANCE_TYPE_ZEP_MAUG = 1498 ;
const int APPEARANCE_TYPE_ZEP_MAUG_LIEUTENANT = 1499 ;
const int APPEARANCE_TYPE_ZEP_MAUG_COMMANDER = 1500 ;
const int APPEARANCE_TYPE_ZEP_OSYLUTH_A = 1501 ;
const int APPEARANCE_TYPE_ZEP_OSYLUTH_B = 1502 ;
const int APPEARANCE_TYPE_ZEP_OSYLUTH_C = 1503 ;
const int APPEARANCE_TYPE_ZEP_MAUG_CAPTAIN = 1504 ;

//***************************************************
//************   Begin Behavioral Constants**********
//***************************************************

//"Restless Dead" skeleton (Undead) constants
const int ZEP_RESTLESS_DEAD_RESPAWN_CHANCE = 25;    //% chance (as an integer) that a "Restless Dead" will spawn a new skeleton upon its death.
const float ZEP_RESTLESS_DEAD_RESPAWN_TIME = 10.0;  //Delay in time between restless dead respawns.
